/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
 */
//
//  IdeaShareDef.h
//  ideaShareSDK_ios
//
//  Created by huawei on 2021/1/26.
//  Copyright © 2021 huawei. All rights reserved.
//

#ifndef IdeaShareDef_h
#define IdeaShareDef_h
#import<Foundation/Foundation.h>

typedef NS_ENUM(NSInteger, IDEA_SHARE_APP_DEFINATION_QUALITY) {
    QUALITY_FLUENCY_FIRST = 0,
    QUALITY_CLEAR_FIRST,
    QUALITY_ADAPTIVE
};

typedef NS_ENUM(NSInteger, IDEA_SHARE_APP_CONF_STATUS)
{ IDEA_SHARE_SDK_CONF_IDLE = 0, IDEA_SHARE_SDK_CONF_BUSY };

typedef NS_ENUM(NSInteger, IDEA_SHARE_APP_AUX_STATUS) { IDEA_SHARE_SDK_AUX_IDLE = 0, IDEA_SHARE_SDK_AUX_BUSY };

typedef NS_ENUM(NSInteger, LOG_LEVEL) { IDEA_LEVEL_ERROR = 0, IDEA_LEVEL_WARNING, IDEA_LEVEL_INFO, IDEA_LEVEL_DEBUG };
typedef NS_ENUM(NSInteger, IDEA_SHARE_APP_ERR) {
    DISCOVER_ERROR = 0,
    CONNECT_ERROR,
    DISCONNECT_ERROR,
    SHARE_PLAY_ERROR,
    SHARE_STOP_ERROR,                // 停止投屏错误 4
    GET_REMOTE_SERVICE_STATUS_ERROR, // 遥控器参数查询结果错误 5
    SET_REMOTE_MIC_MUTE_ERROR,       // 打开或关闭麦克风结果错误6
    SET_REMOTE_SPEAKER_VOLUME_ERROR, // 调节扬声器音量结果错误 7
    SET_REMOTE_SPEAKER_MUTE_ERROR,   // 打开\关闭扬声器结果错误 8
    SET_REMOTE_CAMERA_MUTE_ERROR,    // 打开\关闭摄像机结果错误  9
    LEAVE_CONFERENCE_ERROR,          // 离开会议结果错误 10
    END_CONFERENCE_ERROR,            // 结束会议结果错误 11
    GET_SDK_LATEST_VERSION_ERROR,    // 获取SDK最新版本12
    PROCESS_CONNECTING_ERROR,        // 正在处理连接请求
    IN_CONNECTION_ERROR,             // 客户端已处于连接
    PROJECTION_CODE_ERROR,           // 投影码错误 数字+字母组合
    AUTH_ERROR,                      // 鉴权失败
    CLIENT_IS_LOCKED_ERROR,          // 客户端被锁定
    CONNECT_BUSY_ERROR,              // 终端忙碌
    CONNECT_UPDATING_ERROR,          // 终端正在升级
    WEB_DENY_ERROR,                  // WEB被禁用 20
    NO_COMMON_DATA_CAP_ERROR,        /* *< 和客户端没有辅流公共能力    */
    GET_TOKEN_FAILD_ERROR,           /* *< 获取辅流令牌失败  */
    LOW_BANDWIDTH_ERROR,             /* *< 带宽过低，无法发送辅流 */
    CONF_NO_DATA_CAP_ERROR,
    MULTICONNECT_BUSY_ERROR,
    EUA_AUTH_ERROR,
    EUA_IS_LOCKED_ERROR
};

typedef NS_ENUM(NSInteger, IDEA_SHARE_APP_SERVER_STATUS) {
    SERVER_STATUS_CONNECT,
    SERVER_STATUS_SHARE,
    SERVER_STATUS_STOP_SHARE,
    SERVER_STATUS_DISCONNECT,
};

typedef NS_ENUM(NSInteger, IDEA_SHARE_APP_TLS_VERIFY_MODE)
{
    TLS_VERIFY_MODE_NONE = 0,
    TLS_VERIFY_MODE_SERVER,
    TLS_VERIFY_MODE_CLIENT,
    TLS_VERIFY_MODE_BOTH,
    TLS_VERIFY_MODE_BUTT
};

@interface IdeaShareServiceTlsInfo : NSObject
@property(nonatomic, copy)NSString *caCertpath;
@property(nonatomic, copy)NSString *clientCertpath;
@property(nonatomic, assign)IDEA_SHARE_APP_TLS_VERIFY_MODE verifyMode;
@end

@interface IdeaShareServiceAppInfo : NSObject
@property(nonatomic, copy) NSString *appInfo;
@property(nonatomic, copy) NSString *exePath;
@end


@interface IdeaShareServiceLogInfo : NSObject
@property(nonatomic, copy) NSString *path;
@property(nonatomic, assign) LOG_LEVEL logLevel;
@property(nonatomic, assign) bool enable;
@end


@interface SharePolicy : NSObject
@property(nonatomic, assign) IDEA_SHARE_APP_DEFINATION_QUALITY shareQuality;
@property(nonatomic, assign) bool isShareAudio;
@property(nonatomic, assign) bool isCompatibility;

@end


@interface DeviceInfo : NSObject
@property(nonatomic, copy) NSString *deviceAddress;
@property(nonatomic, copy) NSString *deviceName;
@property(nonatomic, assign) bool isSupportRemote;

@end


@interface DiscoverResult : NSObject
@property(nonatomic, assign) int result;
@property(nonatomic, copy) NSString *password;
@property(nonatomic, strong) NSMutableArray *address_list;
@end


@interface RemoteServiceStatus : NSObject
@property(nonatomic, assign) bool isMute; // microphone
@property(nonatomic, assign) bool isCameraMute;
@property(nonatomic, assign) int volume;
@property(nonatomic, assign) bool isSpeakerMute;
@property(nonatomic, assign) bool isChairman;
@property(nonatomic, assign) bool isBase;
@end

#endif /* IdeaShareDef_h */
